Index: sys/kern/sys_generic.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/sys_generic.c,v
retrieving revision 1.58
retrieving revision 1.58.6.5
diff -u -r1.58 -r1.58.6.5
--- sys/kern/sys_generic.c	7 Sep 2007 15:00:20 -0000	1.58
+++ sys/kern/sys_generic.c	18 Feb 2009 12:43:25 -0000	1.58.6.5
@@ -564,6 +564,7 @@
 
 			so->so_pgid = tmp;
 			so->so_siguid = p->p_cred->p_ruid;
+			so->so_siginstid = p->p_inst->inst_id;
 			so->so_sigeuid = p->p_ucred->cr_uid;
 			error = 0;
 			break;
@@ -571,7 +572,7 @@
 		if (tmp <= 0) {
 			tmp = -tmp;
 		} else {
-			struct proc *p1 = pfind(tmp);
+			struct proc *p1 = pfind(p->p_inst->inst_proc, tmp);
 			if (p1 == 0) {
 				error = ESRCH;
 				break;
@@ -782,15 +783,20 @@
 {
 	struct proc *p;
 	pid_t mypid;
+	instid_t myinst;
 
 	mypid = selector->p_pid;
-	if (sip->si_selpid == mypid)
+	myinst = selector->p_inst->inst_id;
+
+	if (sip->si_selpid == mypid && sip->si_selinst == myinst)
 		return;
-	if (sip->si_selpid && (p = pfind(sip->si_selpid)) &&
+	if (sip->si_selpid && (p = pfind(selector->p_inst->inst_proc, sip->si_selpid)) &&
 	    p->p_wchan == (caddr_t)&selwait)
 		sip->si_flags |= SI_COLL;
-	else
+	else {
 		sip->si_selpid = mypid;
+		sip->si_selinst = myinst;
+	}
 }
 
 /*
@@ -800,6 +806,7 @@
 selwakeup(struct selinfo *sip)
 {
 	struct proc *p;
+	struct inst *inst;
 	int s;
 
 	if (sip->si_selpid == 0)
@@ -809,8 +816,14 @@
 		sip->si_flags &= ~SI_COLL;
 		wakeup(&selwait);
 	}
-	p = pfind(sip->si_selpid);
+
+	inst = instkfind(sip->si_selinst);
+	if (NULL == inst)
+		return;
+
+	p = pfind(inst->inst_proc, sip->si_selpid);
 	sip->si_selpid = 0;
+
 	if (p != NULL) {
 		SCHED_LOCK(s);
 		if (p->p_wchan == (caddr_t)&selwait) {
Index: sys/kern/sys_pipe.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/sys_pipe.c,v
retrieving revision 1.54
retrieving revision 1.54.4.1
diff -u -r1.54 -r1.54.4.1
--- sys/kern/sys_pipe.c	11 Jul 2008 14:12:57 -0000	1.54
+++ sys/kern/sys_pipe.c	19 Sep 2008 08:54:27 -0000	1.54.4.1
@@ -89,7 +89,7 @@
 
 void	pipeclose(struct pipe *);
 void	pipe_free_kmem(struct pipe *);
-int	pipe_create(struct pipe *);
+int	pipe_create(struct proc *, struct pipe *);
 int	pipelock(struct pipe *);
 void	pipeunlock(struct pipe *);
 void	pipeselwakeup(struct pipe *);
@@ -111,11 +111,11 @@
 	fdplock(fdp);
 
 	rpipe = pool_get(&pipe_pool, PR_WAITOK);
-	error = pipe_create(rpipe);
+	error = pipe_create(p, rpipe);
 	if (error != 0)
 		goto free1;
 	wpipe = pool_get(&pipe_pool, PR_WAITOK);
-	error = pipe_create(wpipe);
+	error = pipe_create(p, wpipe);
 	if (error != 0)
 		goto free2;
 
@@ -192,7 +192,7 @@
  * initialize and allocate VM and memory for pipe
  */
 int
-pipe_create(struct pipe *cpipe)
+pipe_create(struct proc *proc, struct pipe *cpipe)
 {
 	int error;
 
@@ -215,6 +215,7 @@
 	cpipe->pipe_atime = cpipe->pipe_ctime;
 	cpipe->pipe_mtime = cpipe->pipe_ctime;
 	cpipe->pipe_pgid = NO_PID;
+	cpipe->pipe_instid = proc->p_inst->inst_id;
 
 	return (0);
 }
@@ -257,7 +258,7 @@
 		selwakeup(&cpipe->pipe_sel);
 	}
 	if ((cpipe->pipe_state & PIPE_ASYNC) && cpipe->pipe_pgid != NO_PID)
-		gsignal(cpipe->pipe_pgid, SIGIO);
+		gsignal(cpipe->pipe_instid, cpipe->pipe_pgid, SIGIO);
 	KNOTE(&cpipe->pipe_sel.si_note, 0);
 }
 
Index: sys/kern/sys_process.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/sys_process.c,v
retrieving revision 1.39
retrieving revision 1.39.8.3
diff -u -r1.39 -r1.39.8.3
--- sys/kern/sys_process.c	10 Apr 2007 17:47:55 -0000	1.39
+++ sys/kern/sys_process.c	18 Feb 2009 12:43:25 -0000	1.39.8.3
@@ -106,7 +106,7 @@
 	else {
 
 		/* Find the process we're supposed to be operating on. */
-		if ((t = pfind(SCARG(uap, pid))) == NULL)
+		if ((t = pfind(p->p_inst->inst_proc, SCARG(uap, pid))) == NULL)
 			return (ESRCH);
 	}
 
@@ -367,8 +367,8 @@
 		if (t->p_oppid != t->p_pptr->p_pid) {
 			struct proc *pp;
 
-			pp = pfind(t->p_oppid);
-			proc_reparent(t, pp ? pp : initproc);
+			pp = pfind(p->p_inst->inst_proc, t->p_oppid);
+			proc_reparent(t, pp ? pp : p->p_inst->inst_proc->initproc);
 		}
 
 		/* not being traced any more */
Index: sys/kern/sys_socket.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/sys_socket.c,v
retrieving revision 1.12
retrieving revision 1.12.4.1
diff -u -r1.12 -r1.12.4.1
--- sys/kern/sys_socket.c	23 May 2008 15:51:12 -0000	1.12
+++ sys/kern/sys_socket.c	20 Sep 2008 00:09:45 -0000	1.12.4.1
@@ -103,6 +103,7 @@
 	case SIOCSPGRP:
 		so->so_pgid = *(int *)data;
 		so->so_siguid = p->p_cred->p_ruid;
+		so->so_siginstid = p->p_inst->inst_id;
 		so->so_sigeuid = p->p_ucred->cr_uid;
 		return (0);
 
Index: sys/kern/syscalls.master
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/syscalls.master,v
retrieving revision 1.90
retrieving revision 1.90.4.3
diff -u -r1.90 -r1.90.4.3
--- sys/kern/syscalls.master	16 Mar 2008 19:42:57 -0000	1.90
+++ sys/kern/syscalls.master	13 Feb 2009 09:08:59 -0000	1.90.4.3
@@ -618,3 +618,6 @@
 308	STD		{ int sys_fstatfs(int fd, struct statfs *buf); }
 309	STD		{ int sys_fhstatfs(const fhandle_t *fhp, \
 			    struct statfs *buf); }
+310	STD		{ instid_t sys_forkinst(instid_t id); }
+311	STD NOLOCK	{ instid_t sys_getinstid(void); }
+312	STD		{ int sys_killinst(instid_t id, int signum); }
Index: sys/kern/tty.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/tty.c,v
retrieving revision 1.77
retrieving revision 1.77.4.1
diff -u -r1.77 -r1.77.4.1
--- sys/kern/tty.c	28 Jul 2008 06:13:22 -0000	1.77
+++ sys/kern/tty.c	18 Sep 2008 17:21:03 -0000	1.77.4.1
@@ -990,7 +990,7 @@
 		atomic_setbits_int(&p->p_flag, P_CONTROLT);
 		break;
 	case TIOCSPGRP: {		/* set pgrp of tty */
-		struct pgrp *pgrp = pgfind(*(int *)data);
+		struct pgrp *pgrp = pgfind(p->p_inst->inst_proc, *(int *)data);
 
 		if (!isctty(p, tp))
 			return (ENOTTY);
Index: sys/kern/tty_pty.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/tty_pty.c,v
retrieving revision 1.38
retrieving revision 1.38.4.1
diff -u -r1.38 -r1.38.4.1
--- sys/kern/tty_pty.c	2 Aug 2008 11:39:38 -0000	1.38
+++ sys/kern/tty_pty.c	12 Sep 2008 13:58:49 -0000	1.38.4.1
@@ -1044,7 +1044,7 @@
 	/*
 	 * Get us a fresh cred with root privileges.
 	 */
-	cred = crget();
+	cred = crget(p->p_inst);
 	error = VOP_OPEN(vp, FREAD|FWRITE, cred, p);
 	if (!error) {
 		/* update atime/mtime */
@@ -1185,7 +1185,7 @@
 			vattr.va_gid = gid;
 			vattr.va_mode = (S_IRUSR|S_IWUSR|S_IWGRP) & ALLPERMS;
 			/* Get a fake cred to pretend we're root. */
-			cred = crget();
+			cred = crget(p->p_inst);
 			error = VOP_SETATTR(snd.ni_vp, &vattr, cred, p);
 			crfree(cred);
 			if (error) {
Index: sys/kern/uipc_socket.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/uipc_socket.c,v
retrieving revision 1.71
retrieving revision 1.71.4.1
diff -u -r1.71 -r1.71.4.1
--- sys/kern/uipc_socket.c	14 Jun 2008 10:55:21 -0000	1.71
+++ sys/kern/uipc_socket.c	20 Sep 2008 00:09:45 -0000	1.71.4.1
@@ -1201,7 +1201,8 @@
 void
 sohasoutofband(struct socket *so)
 {
-	csignal(so->so_pgid, SIGURG, so->so_siguid, so->so_sigeuid);
+	csignal(so->so_siginstid, so->so_pgid, 
+			SIGURG, so->so_siguid, so->so_sigeuid);
 	selwakeup(&so->so_rcv.sb_sel);
 }
 
Index: sys/kern/uipc_socket2.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/uipc_socket2.c,v
retrieving revision 1.44
retrieving revision 1.44.4.1
diff -u -r1.44 -r1.44.4.1
--- sys/kern/uipc_socket2.c	23 May 2008 15:51:12 -0000	1.44
+++ sys/kern/uipc_socket2.c	20 Sep 2008 00:09:45 -0000	1.44.4.1
@@ -178,6 +178,7 @@
 	so->so_egid = head->so_egid;
 	so->so_rgid = head->so_rgid;
 	so->so_cpid = head->so_cpid;
+	so->so_siginstid = head->so_siginstid;
 	so->so_siguid = head->so_siguid;
 	so->so_sigeuid = head->so_sigeuid;
 
@@ -324,7 +325,8 @@
 		wakeup(&sb->sb_cc);
 	}
 	if (so->so_state & SS_ASYNC)
-		csignal(so->so_pgid, SIGIO, so->so_siguid, so->so_sigeuid);
+		csignal(so->so_siginstid, so->so_pgid, SIGIO, 
+				so->so_siguid, so->so_sigeuid);
 	KNOTE(&sb->sb_sel.si_note, 0);
 }
 
Index: sys/kern/vfs_syscalls.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/kern/vfs_syscalls.c,v
retrieving revision 1.148
retrieving revision 1.148.4.2
diff -u -r1.148 -r1.148.4.2
--- sys/kern/vfs_syscalls.c	28 Jul 2008 14:21:17 -0000	1.148
+++ sys/kern/vfs_syscalls.c	16 Sep 2008 23:10:38 -0000	1.148.4.2
@@ -64,7 +64,7 @@
 
 static int change_dir(struct nameidata *, struct proc *);
 
-void checkdirs(struct vnode *);
+void checkdirs(struct proc *, struct vnode *);
 
 int copyout_statfs(struct statfs *, void *, struct proc *);
 
@@ -297,7 +297,7 @@
 	if (!error) {
 		vfsp->vfc_refcount++;
 		CIRCLEQ_INSERT_TAIL(&mountlist, mp, mnt_list);
-		checkdirs(vp);
+		checkdirs(p, vp);
 		VOP_UNLOCK(vp, 0, p);
  		if ((mp->mnt_flag & MNT_RDONLY) == 0)
  			error = vfs_allocate_syncvnode(mp);
@@ -320,7 +320,7 @@
  * mounted. If so, replace them with the new mount point.
  */
 void
-checkdirs(struct vnode *olddp)
+checkdirs(struct proc *curp, struct vnode *olddp)
 {
 	struct filedesc *fdp;
 	struct vnode *newdp;
@@ -330,7 +330,7 @@
 		return;
 	if (VFS_ROOT(olddp->v_mountedhere, &newdp))
 		panic("mount: lost mount");
-	LIST_FOREACH(p, &allproc, p_list) {
+	PROCLIST_FOREACH(p, curp, p_list) {
 		fdp = p->p_fd;
 		if (fdp->fd_cdir == olddp) {
 			vrele(fdp->fd_cdir);
Index: sys/miscfs/procfs/procfs_ctl.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/miscfs/procfs/procfs_ctl.c,v
retrieving revision 1.21
retrieving revision 1.21.8.2
diff -u -r1.21 -r1.21.8.2
--- sys/miscfs/procfs/procfs_ctl.c	18 Jun 2007 08:30:07 -0000	1.21
+++ sys/miscfs/procfs/procfs_ctl.c	27 Sep 2008 14:09:44 -0000	1.21.8.2
@@ -138,6 +138,7 @@
 		atomic_setbits_int(&p->p_flag, P_TRACED);
 		p->p_xstat = 0;		/* XXX ? */
 		if (p->p_pptr != curp) {
+			/* FIXME: instances */
 			p->p_oppid = p->p_pptr->p_pid;
 			proc_reparent(p, curp);
 		}
@@ -187,10 +188,11 @@
 		atomic_clearbits_int(&p->p_flag, P_TRACED);
 
 		/* give process back to original parent */
+		KASSERT(p->p_pptr); /* FIXME: instances. */
 		if (p->p_oppid != p->p_pptr->p_pid) {
 			struct proc *pp;
 
-			pp = pfind(p->p_oppid);
+			pp = pfind(curp->p_inst->inst_proc, p->p_oppid);
 			if (pp)
 				proc_reparent(p, pp);
 		}
Index: sys/miscfs/procfs/procfs_subr.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/miscfs/procfs/procfs_subr.c,v
retrieving revision 1.28
retrieving revision 1.28.6.1
diff -u -r1.28 -r1.28.6.1
--- sys/miscfs/procfs/procfs_subr.c	9 Dec 2007 21:34:32 -0000	1.28
+++ sys/miscfs/procfs/procfs_subr.c	16 Sep 2008 23:10:38 -0000	1.28.6.1
@@ -201,7 +201,7 @@
 	struct pfsnode *pfs = VTOPFS(vp);
 	struct proc *p;
 
-	p = pfind(pfs->pfs_pid);
+	p = pfind(curp->p_inst->inst_proc, pfs->pfs_pid);
 	if (p == 0)
 		return (EINVAL);
 	/* Do not permit games to be played with init(8) */
Index: sys/miscfs/procfs/procfs_vfsops.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/miscfs/procfs/procfs_vfsops.c,v
retrieving revision 1.25
retrieving revision 1.25.8.3
diff -u -r1.25 -r1.25.8.3
--- sys/miscfs/procfs/procfs_vfsops.c	18 Jun 2007 08:30:07 -0000	1.25
+++ sys/miscfs/procfs/procfs_vfsops.c	18 Feb 2009 12:43:25 -0000	1.25.8.3
@@ -76,6 +76,11 @@
 	struct procfs_args args;
 	int error;
 
+	/* FIXME - instances. */
+	log(LOG_ERR, "procfs: not supported with instances");
+	return(EINVAL);
+	/* FIXME - instances. */
+
 	if (UIO_MX & (UIO_MX-1)) {
 		log(LOG_ERR, "procfs: invalid directory entry size");
 		return (EINVAL);
Index: sys/miscfs/procfs/procfs_vnops.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/miscfs/procfs/procfs_vnops.c,v
retrieving revision 1.45
retrieving revision 1.45.4.4
diff -u -r1.45 -r1.45.4.4
--- sys/miscfs/procfs/procfs_vnops.c	9 Jun 2008 23:38:37 -0000	1.45
+++ sys/miscfs/procfs/procfs_vnops.c	18 Feb 2009 12:43:26 -0000	1.45.4.4
@@ -197,7 +197,7 @@
 	struct proc *p2;		/* traced */
 	int error;
 
-	if ((p2 = pfind(pfs->pfs_pid)) == 0)
+	if ((p2 = pfind(p1->p_inst->inst_proc, pfs->pfs_pid)) == 0)
 		return (ENOENT);	/* was ESRCH, jsp */
 
 	switch (pfs->pfs_type) {
@@ -294,7 +294,8 @@
 	struct vnode *vp = ap->a_vp;
 	struct pfsnode *pfs = VTOPFS(vp);
 
-	if (pfind(pfs->pfs_pid) == NULL && !(vp->v_flag & VXLOCK))
+	/* FIXME: instances. */
+	if (pfind(proc0.p_inst->inst_proc, pfs->pfs_pid) == NULL && !(vp->v_flag & VXLOCK))
 		vgone(vp);
 
 	return (0);
@@ -424,7 +425,8 @@
 		break;
 
 	default:
-		procp = pfind(pfs->pfs_pid);
+		/* FIXME: instances. */
+		procp = pfind(proc0.p_inst->inst_proc, pfs->pfs_pid);
 		if (procp == 0)
 			return (ENOENT);
 	}
@@ -704,7 +706,7 @@
 		if (pid == NO_PID)
 			break;
 
-		p = pfind(pid);
+		p = pfind(curp->p_inst->inst_proc, pid);
 		if (p == 0)
 			break;
 
@@ -732,7 +734,7 @@
 			return (error);
 		}
 
-		p = pfind(pfs->pfs_pid);
+		p = pfind(curp->p_inst->inst_proc, pfs->pfs_pid);
 		if (p == 0)
 			break;
 
@@ -837,7 +839,8 @@
 		struct proc *p;
 		struct proc_target *pt;
 
-		p = pfind(pfs->pfs_pid);
+		/* FIXME: instances. */
+		p = pfind(proc0.p_inst->inst_proc, pfs->pfs_pid);
 		if (p == NULL)
 			break;
 
@@ -873,7 +876,9 @@
 		int doingzomb = 0;
 #endif
 		int pcnt = i;
-		volatile struct proc *p = LIST_FIRST(&allproc);
+		/* FIXME */
+		volatile struct proc *p = 
+			LIST_FIRST(&curproc->p_inst->inst_proc->allproc);
 
 		if (pcnt > 3)
 			pcnt = 3;
@@ -950,7 +955,7 @@
 #ifdef PROCFS_ZOMBIE
 		if (p == 0 && doingzomb == 0) {
 			doingzomb = 1;
-			p = LIST_FIRST(&zombproc);
+			p = LIST_FIRST(curproc->p_inst->inst_proc->zombproc);
 			goto again;
 		}
 #endif
Index: sys/net/bpf.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/net/bpf.c,v
retrieving revision 1.68
retrieving revision 1.68.6.2
diff -u -r1.68 -r1.68.6.2
--- sys/net/bpf.c	25 Jan 2008 16:14:56 -0000	1.68
+++ sys/net/bpf.c	20 Sep 2008 00:09:45 -0000	1.68.6.2
@@ -492,7 +492,7 @@
 {
 	wakeup((caddr_t)d);
 	if (d->bd_async && d->bd_sig)
-		csignal(d->bd_pgid, d->bd_sig,
+		csignal(d->bd_siginstid, d->bd_pgid, d->bd_sig,
 		    d->bd_siguid, d->bd_sigeuid);
 
 	selwakeup(&d->bd_sel);
@@ -856,6 +856,7 @@
 	 */
 	case TIOCSPGRP:		/* Process or group to send signals to */
 		d->bd_pgid = *(int *)addr;
+		d->bd_siginstid = p->p_inst->inst_id;
 		d->bd_siguid = p->p_cred->p_ruid;
 		d->bd_sigeuid = p->p_ucred->cr_uid;
 		break;
Index: sys/net/bpfdesc.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/net/bpfdesc.h,v
retrieving revision 1.17
retrieving revision 1.17.12.1
diff -u -r1.17 -r1.17.12.1
--- sys/net/bpfdesc.h	25 Mar 2006 22:41:47 -0000	1.17
+++ sys/net/bpfdesc.h	19 Sep 2008 11:07:33 -0000	1.17.12.1
@@ -82,6 +82,7 @@
 	int		bd_async;	/* non-zero if packet reception should generate signal */
 	int		bd_sig;		/* signal to send upon packet reception */
 	pid_t		bd_pgid;	/* process or group id for signal */
+	instid_t	bd_siginstid;	/* instance for process for signal */
 	uid_t		bd_siguid;	/* uid for process that set pgid */
 	uid_t		bd_sigeuid;	/* euid for process that set pgid */
 	u_int		bd_ref;		/* reference count */
Index: sys/net/if_tun.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/net/if_tun.c,v
retrieving revision 1.94
retrieving revision 1.94.4.2
diff -u -r1.94 -r1.94.4.2
--- sys/net/if_tun.c	4 Aug 2008 18:55:08 -0000	1.94
+++ sys/net/if_tun.c	20 Sep 2008 00:09:45 -0000	1.94.4.2
@@ -90,6 +90,7 @@
 	struct arpcom	arpcom;		/* ethernet common data */
 	u_short		tun_flags;	/* misc flags */
 	pid_t		tun_pgid;	/* the process group - if any */
+	instid_t	tun_siginstid;	/* instid for process that set tun_pgid */
 	uid_t		tun_siguid;	/* uid for process that set tun_pgid */
 	uid_t		tun_sigeuid;	/* euid for process that set tun_pgid */
 	struct selinfo	tun_rsel;	/* read select */
@@ -585,7 +586,7 @@
 		wakeup((caddr_t)tp);
 	}
 	if (tp->tun_flags & TUN_ASYNC && tp->tun_pgid)
-		csignal(tp->tun_pgid, SIGIO,
+		csignal(tp->tun_siginstid, tp->tun_pgid, SIGIO,
 		    tp->tun_siguid, tp->tun_sigeuid);
 	selwakeup(&tp->tun_rsel);
 	KNOTE(&tp->tun_rsel.si_note, 0);
@@ -669,6 +670,7 @@
 		break;
 	case TIOCSPGRP:
 		tp->tun_pgid = *(int *)data;
+		tp->tun_siginstid = p->p_inst->inst_id;
 		tp->tun_siguid = p->p_cred->p_ruid;
 		tp->tun_sigeuid = p->p_ucred->cr_uid;
 		break;
Index: sys/nfs/nfs_vfsops.c
===================================================================
RCS file: /cvs/OpenBSD/src/sys/nfs/nfs_vfsops.c,v
retrieving revision 1.79
retrieving revision 1.79.4.1
diff -u -r1.79 -r1.79.4.1
--- sys/nfs/nfs_vfsops.c	28 Jul 2008 13:35:14 -0000	1.79
+++ sys/nfs/nfs_vfsops.c	12 Sep 2008 13:58:49 -0000	1.79.4.1
@@ -125,7 +125,7 @@
 	if (error)
 		return (error);
 	vp = NFSTOV(np);
-	cred = crget();
+	cred = crget(p->p_inst);
 	cred->cr_ngroups = 0;
 	if (v3 && (nmp->nm_flag & NFSMNT_GOTFSINFO) == 0)
 		(void)nfs_fsinfo(nmp, vp, cred, p);
Index: sys/sys/_types.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/_types.h,v
retrieving revision 1.2
retrieving revision 1.2.4.1
diff -u -r1.2 -r1.2.4.1
--- sys/sys/_types.h	16 Mar 2008 19:42:57 -0000	1.2
+++ sys/sys/_types.h	12 Sep 2008 13:58:49 -0000	1.2.4.1
@@ -58,6 +58,7 @@
 typedef	__int32_t	__suseconds_t;	/* microseconds (signed) */
 typedef __uint64_t	__fsblkcnt_t;	/* file system block count */
 typedef __uint64_t	__fsfilcnt_t;	/* file system file count */
+typedef __uint32_t	__instid_t;	/* instance id */
 
 /*
  * mbstate_t is an opaque object to keep conversion state, during multibyte
Index: sys/sys/errno.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/errno.h,v
retrieving revision 1.20
retrieving revision 1.20.6.2
diff -u -r1.20 -r1.20.6.2
--- sys/sys/errno.h	3 Sep 2007 14:37:52 -0000	1.20
+++ sys/sys/errno.h	13 Feb 2009 09:09:00 -0000	1.20.6.2
@@ -166,8 +166,13 @@
 #endif /* __BSD_VISIBLE */
 #define	EIDRM		89		/* Identifier removed */
 #define	ENOMSG		90		/* No message of desired type */
+
+/* instances */
+#define	EINSTSRCH	91		/* instance not found */
+#define	EINSTEXIST	92
+
 #if __BSD_VISIBLE
-#define	ELAST		90		/* Must be equal largest errno */
+#define	ELAST		92		/* Must be equal largest errno */
 #endif /* __BSD_VISIBLE */
 
 #ifdef _KERNEL
Index: sys/sys/inst.h
===================================================================
RCS file: sys/sys/inst.h
diff -N sys/sys/inst.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/sys/inst.h	18 Feb 2009 18:20:20 -0000	1.1.2.10
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2008 Kristaps Dzonsons <kristaps@mult.bsd.lv>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all
+ * copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
+ * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
+ * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
+ * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+ * PERFORMANCE OF THIS SOFTWARE.
+ */
+#ifndef _SYS_INST_H_
+#define	_SYS_INST_H_
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/queue.h>
+
+#define	INST_MAX	(UINT_MAX - 1)
+#define	INST_NOID	(UINT_MAX)
+
+#define	SIGINST_TERM	(15)	/* Send SIGTERM to root. */
+#define	SIGINST_KILL	(9)	/* Send SIGKILL to root. */
+
+struct	inst_proc;
+
+struct	inst {
+	struct inst_proc*inst_proc;
+	LIST_ENTRY(inst) inst_hash;
+	LIST_ENTRY(inst) inst_list;
+	instid_t	 inst_id;
+	u_int		 inst_ref;
+};
+
+#ifdef _KERNEL
+#define insthold(inst) (inst)->inst_ref++
+
+LIST_HEAD(instlist, inst);
+
+extern struct instlist	 inst_all;
+
+enum	instop {
+	INST_KPROC,	/* Read-only statistics. */
+	INST_SIG	/* Deliver signal to a process. */
+};
+
+void			 instinit(void);
+struct inst		*instknew(instid_t);
+struct inst		*instpnew(struct proc *, instid_t);
+struct inst		*instpfind(struct proc *, 
+				instid_t, enum instop);
+struct inst		*instkfind(instid_t);
+void			 instfree(struct inst *);
+
+#endif	/* _KERNEL */
+
+#endif	/* !_SYS_INST_H_ */
Index: sys/sys/malloc.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/malloc.h,v
retrieving revision 1.92
retrieving revision 1.92.4.1
diff -u -r1.92 -r1.92.4.1
--- sys/sys/malloc.h	22 Jun 2008 15:52:54 -0000	1.92
+++ sys/sys/malloc.h	12 Sep 2008 13:58:49 -0000	1.92.4.1
@@ -99,6 +99,7 @@
 #define	M_PROC		41	/* Proc structures */
 #define	M_SUBPROC	42	/* Proc sub-structures */
 #define	M_VCLUSTER	43	/* Cluster for VFS */
+#define	M_INST		44	/* Instance structures */
 /* 45-46 - free */
 #define	M_MFSNODE	46	/* MFS vnode private part */
 /* 47-48 - free */
@@ -230,7 +231,7 @@
 	"proc",		/* 41 M_PROC */ \
 	"subproc",	/* 42 M_SUBPROC */ \
 	"VFS cluster",	/* 43 M_VCLUSTER */ \
-	NULL, \
+	"inst", 	/* 44 M_INST */ \
 	NULL, \
 	"MFS node",	/* 46 M_MFSNODE */ \
 	NULL, \
Index: sys/sys/pipe.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/pipe.h,v
retrieving revision 1.13
retrieving revision 1.13.14.1
diff -u -r1.13 -r1.13.14.1
--- sys/sys/pipe.h	21 Nov 2005 18:16:46 -0000	1.13
+++ sys/sys/pipe.h	19 Sep 2008 08:54:27 -0000	1.13.14.1
@@ -77,6 +77,7 @@
 	struct	timespec pipe_atime;	/* time of last access */
 	struct	timespec pipe_mtime;	/* time of last modify */
 	struct	timespec pipe_ctime;	/* time of status change */
+	instid_t pipe_instid;
 	int	pipe_pgid;		/* process/group for async I/O */
 	struct	pipe *pipe_peer;	/* link with other direction */
 	u_int	pipe_state;		/* pipe status info */
Index: sys/sys/proc.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/proc.h,v
retrieving revision 1.103
retrieving revision 1.103.4.12
diff -u -r1.103 -r1.103.4.12
--- sys/sys/proc.h	5 May 2008 15:37:41 -0000	1.103
+++ sys/sys/proc.h	18 Feb 2009 12:43:26 -0000	1.103.4.12
@@ -53,6 +53,14 @@
 #define __need_process
 #endif
 
+/* 
+ * This refers to whether we internally use "functional" isolation on
+ * the process table in order to speed up performance.  This has NOT
+ * been determined to significantly slow/speed performance, so it'll be
+ * deprecated.  TODO.
+ */
+#define GLOBAL_HASH	0
+
 /*
  * One structure allocated per session.
  */
@@ -71,6 +79,9 @@
 	LIST_ENTRY(pgrp) pg_hash;	/* Hash chain. */
 	LIST_HEAD(, proc) pg_members;	/* Pointer to pgrp members. */
 	struct	session *pg_session;	/* Pointer to session. */
+#ifdef GLOBAL_HASH
+	struct	inst	*pg_inst;
+#endif
 	pid_t	pg_id;			/* Pgrp id. */
 	int	pg_jobc;	/* # procs qualifying pgrp for job control */
 };
@@ -162,6 +173,7 @@
 	struct	sigacts *p_sigacts;	/* Signal actions, state */
 #define	p_cred		p_p->ps_cred
 #define	p_ucred		p_cred->pc_ucred
+#define	p_inst		p_cred->pc_ucred->cr_inst
 #define	p_rlimit	p_p->ps_limit->pl_rlimit
 
 	int	p_exitsig;		/* Signal to send to parent on exit. */
@@ -340,7 +352,6 @@
 	long	ui_lockcnt;	/* lockf structs */
 };
 
-struct uidinfo *uid_find(uid_t);
 
 /*
  * We use process IDs <= PID_MAX; PID_MAX + 1 must also fit in a pid_t,
@@ -375,21 +386,36 @@
 #define EXIT_NORMAL	0x00000001
 #define EXIT_THREAD	0x00000002
 
-#define	PIDHASH(pid)	(&pidhashtbl[(pid) & pidhash])
-extern LIST_HEAD(pidhashhead, proc) *pidhashtbl;
+LIST_HEAD(proclist, proc);
+LIST_HEAD(pidhhead, proc);
+LIST_HEAD(pghhead, pgrp);
+
+#ifdef GLOBAL_HASH
+extern struct pidhhead *pidhashtbl;
 extern u_long pidhash;
 
-#define	PGRPHASH(pgid)	(&pgrphashtbl[(pgid) & pgrphash])
-extern LIST_HEAD(pgrphashhead, pgrp) *pgrphashtbl;
+extern struct pghhead *pgrphashtbl;
 extern u_long pgrphash;
+#endif
 
-extern struct proc proc0;		/* Process slot for swapper. */
-extern int nprocs, maxproc;		/* Current and max number of procs. */
-extern int randompid;			/* fork() should create random pid's */
+struct	inst_proc {
+	struct proclist	 allproc;
+	struct proclist	 zombproc;
+#ifdef GLOBAL_HASH
+	instid_t	 instid; 
+#else /*!GLOBAL_HASH*/
+	struct pidhhead *pidhashtbl;
+	u_long		 pidhash;
+	struct pghhead	*pgrphashtbl;
+	u_long		 pgrphash;
+#endif /*!GLOBAL_HASH*/
+	struct proc	*initproc;
+};
 
-LIST_HEAD(proclist, proc);
-extern struct proclist allproc;		/* List of all processes. */
-extern struct proclist zombproc;	/* List of zombie processes. */
+
+extern struct proc proc0;		/* Process slot for swapper. */
+extern int nprocs, maxproc;		/* Max number of procs. */
+extern int randompid;
 
 extern struct proc *initproc;		/* Process slots for init, pager. */
 extern struct proc *syncerproc;		/* filesystem syncer daemon */
@@ -403,8 +429,9 @@
 
 struct simplelock;
 
-struct proc *pfind(pid_t);	/* Find process by id. */
-struct pgrp *pgfind(pid_t);	/* Find process group by id. */
+struct uidinfo *uid_find(uid_t);
+struct proc *pfind(struct inst_proc *, pid_t);
+struct pgrp *pgfind(struct inst_proc *, pid_t);
 void	proc_printit(struct proc *p, const char *modif,
     int (*pr)(const char *, ...));
 
@@ -427,6 +454,7 @@
 void	exit1(struct proc *, int, int);
 void	exit2(struct proc *);
 void	cpu_exit(struct proc *);
+int	forkinst1(struct proc *, instid_t, register_t *);
 int	fork1(struct proc *, int, int, void *, size_t, void (*)(void *),
 	    void *, register_t *, struct proc **);
 int	groupmember(gid_t, struct ucred *);
@@ -461,7 +489,16 @@
 void	proc_trampoline_mp(void);	/* XXX */
 #endif
 
-int proc_isunder(struct proc *, struct proc *);
+int	proc_isunder(struct proc *, struct proc *);
+
+void		  pgrpinit(struct proc *, struct proc *);
+struct inst_proc *proc_instinit(const struct inst *);
+void		  proc_instfree(struct inst_proc *);
+void		  proc_instadd(struct inst_proc *, struct proc *);
+void		  pgrp_instadd(struct inst_proc *, struct pgrp *);
+
+#define	PROCLIST_FOREACH(x, y, z) \
+	LIST_FOREACH(x, &(y)->p_inst->inst_proc->allproc, z)
 
 #endif	/* _KERNEL */
 #endif	/* !_SYS_PROC_H_ */
Index: sys/sys/selinfo.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/selinfo.h,v
retrieving revision 1.3
retrieving revision 1.3.8.1
diff -u -r1.3 -r1.3.8.1
--- sys/sys/selinfo.h	25 Jul 2007 23:11:53 -0000	1.3
+++ sys/sys/selinfo.h	19 Sep 2008 08:54:27 -0000	1.3.8.1
@@ -41,6 +41,7 @@
  * notified when I/O becomes possible.
  */
 struct selinfo {
+	instid_t si_selinst;
 	pid_t	si_selpid;	/* process to be notified */
 	struct	klist si_note;	/* kernel note list */
 	short	si_flags;	/* see below */
Index: sys/sys/signalvar.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/signalvar.h,v
retrieving revision 1.16
retrieving revision 1.16.10.2
diff -u -r1.16 -r1.16.10.2
--- sys/sys/signalvar.h	6 Feb 2007 18:42:37 -0000	1.16
+++ sys/sys/signalvar.h	20 Sep 2008 00:09:45 -0000	1.16.10.2
@@ -154,8 +154,8 @@
  */
 int	coredump(struct proc *p);
 void	execsigs(struct proc *p);
-void	gsignal(int pgid, int sig);
-void	csignal(pid_t pgid, int signum, uid_t uid, uid_t euid);
+void	gsignal(instid_t instid, int pgid, int sig);
+void	csignal(instid_t instid, pid_t pgid, int signum, uid_t uid, uid_t euid);
 int	issignal(struct proc *p);
 void	pgsignal(struct pgrp *pgrp, int sig, int checkctty);
 void	postsig(int sig);
Index: sys/sys/socketvar.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/socketvar.h,v
retrieving revision 1.41
retrieving revision 1.41.4.1
diff -u -r1.41 -r1.41.4.1
--- sys/sys/socketvar.h	23 May 2008 15:51:12 -0000	1.41
+++ sys/sys/socketvar.h	20 Sep 2008 00:09:45 -0000	1.41.4.1
@@ -72,6 +72,7 @@
 	short	so_timeo;		/* connection timeout */
 	u_short	so_error;		/* error affecting connection */
 	pid_t	so_pgid;		/* pgid for signals */
+	instid_t so_siginstid;		/* instid of process who set so_pgid */
 	uid_t	so_siguid;		/* uid of process who set so_pgid */
 	uid_t	so_sigeuid;		/* euid of process who set so_pgid */
 	u_long	so_oobmark;		/* chars to oob mark */
Index: sys/sys/sysctl.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/sysctl.h,v
retrieving revision 1.92
retrieving revision 1.92.6.2
diff -u -r1.92 -r1.92.6.2
--- sys/sys/sysctl.h	9 Feb 2008 15:10:58 -0000	1.92
+++ sys/sys/sysctl.h	31 Jan 2009 19:14:55 -0000	1.92.6.2
@@ -184,7 +184,9 @@
 #define	KERN_TIMECOUNTER	69	/* node: timecounter */
 #define	KERN_MAXLOCKSPERUID	70	/* int: locks per uid */
 #define	KERN_CPTIME2		71	/* array: cp_time2 */
-#define	KERN_MAXID		72	/* number of valid kern ids */
+#define	KERN_INST		72	/* struct: instance entries */
+#define	KERN_INSTPROC2		73	/* struct: process entries */
+#define	KERN_MAXID		74	/* number of valid kern ids */
 
 #define	CTL_KERN_NAMES { \
 	{ 0, 0 }, \
@@ -259,6 +261,7 @@
  	{ "timecounter", CTLTYPE_NODE }, \
  	{ "maxlocksperuid", CTLTYPE_INT }, \
  	{ "cp_time2", CTLTYPE_STRUCT }, \
+ 	{ "inst", CTLTYPE_STRUCT }, \
 }
 
 /*
@@ -269,6 +272,11 @@
 #define KERN_EMUL_NAME		0
 #define KERN_EMUL_ENABLED	1
 
+/*
+ * KERN_INST subtypes
+ */
+#define	KERN_INST_ALL		0	/* everything */
+#define	KERN_INST_INSTID	1	/* by instance id */		
 
 /*
  * KERN_PROC subtypes
@@ -347,6 +355,11 @@
 
 #define KI_NOCPU	(~(u_int64_t)0)
 
+struct kinfo_inst {
+	u_int32_t inst_id;
+	u_int32_t inst_ref;
+};
+
 struct kinfo_proc2 {
 	u_int64_t p_forw;		/* PTR: linked run/sleep queue. */
 	u_int64_t p_back;
@@ -687,7 +700,8 @@
 int sysctl_rdstruct(void *, size_t *, void *, const void *, int);
 int sysctl_struct(void *, size_t *, void *, size_t, void *, int);
 int sysctl_file(char *, size_t *);
-int sysctl_doproc(int *, u_int, char *, size_t *);
+int sysctl_doproc(struct proc *, int *, u_int, char *, size_t *);
+int sysctl_doinst(struct proc *, int *, u_int, char *, size_t *);
 struct radix_node;
 struct walkarg;
 int sysctl_dumpentry(struct radix_node *, void *);
Index: sys/sys/types.h
===================================================================
RCS file: /cvs/OpenBSD/src/sys/sys/types.h,v
retrieving revision 1.31
retrieving revision 1.31.4.1
diff -u -r1.31 -r1.31.4.1
--- sys/sys/types.h	16 Mar 2008 19:42:57 -0000	1.31
+++ sys/sys/types.h	12 Sep 2008 13:58:49 -0000	1.31.4.1
@@ -148,6 +148,7 @@
 typedef	__suseconds_t	suseconds_t;	/* microseconds (signed) */
 typedef	__fsblkcnt_t	fsblkcnt_t;	/* file system block count */
 typedef	__fsfilcnt_t	fsfilcnt_t;	/* file system file count */
+typedef	__instid_t	instid_t;	/* instance id */
 
 /*
  * XPG4.2 states that inclusion of <netinet/in.h> must pull these
